#include "ps2.h"

int x,y;

ps2 mouse(8, 9);

/*
 * initialize the mouse. Reset it, and place it into remote
 * mode, so we can get the encoder data on demand.
 */
void mouse_init()
{
  mouse.write(0xff);  // reset
  mouse.read();  // ack byte
  mouse.read();  // blank */
  mouse.read();  // blank */
  mouse.write(0xf0);  // remote mode
  mouse.read();  // ack
  delayMicroseconds(100);
}

void setup()
{
  Serial.begin(9600);
  mouse_init();
}

/*
 * get a reading from the mouse and report it back to the
 * host via the serial line.
 */
void loop()
{
  mouse_loop();
  
  Serial.print("X=");
  Serial.print(x);
  Serial.print("\tY=");
  Serial.print(y);
  Serial.println();
//  delay(20);  /* twiddle */
}

void mouse_loop()
{
  char mstat;
  char mx;
  char my;
  
  /* get a reading from the mouse */
  mouse.write(0xeb);  // give me data!
  mouse.read();      // ignore ack
  mstat = mouse.read();
  mx = mouse.read();
  my = mouse.read();

  x += (int)mx;
  y += (int)my;
}

